unit xCounter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Extctrls;

type
  TxCounter = class(TGraphicControl)
  private
    fMM,fSS:integer;
    fBitmap:TBitmap;
    fCounterBmp:TBitmap;
    NumBmp: array [0..10] of TBitmap; //    
    procedure SetBitmap(bmp:TBitmap);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
  published
    procedure ShowTime(mm,ss:integer);
    property Bitmap: TBitmap read fBitmap write SetBitmap;
    property Hint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
  end;

procedure Register;

implementation
{------------------------------------------------------------------------------}
constructor TxCounter.Create(AOwner:TComponent);
var i:integer;
begin
   inherited;
   Width:=52;
   Height:=19;
   fBitmap:=TBitmap.Create;
   fMM:=0; fSS:=0;

   fCounterBmp:=TBitmap.Create;
   fCounterBmp.Width:=52; fCounterBmp.Height:=19;
   fCounterBmp.Canvas.Brush.Color:=clBlack;
   fCounterBmp.Canvas.FillRect(Rect(0,0,52,19));

   For i:=0 To 10 Do
   Begin
    NumBmp[i]:=TBitmap.Create;
   End;
end;
{------------------------------------------------------------------------------}
destructor TxCounter.Destroy;
var i:integer;
begin
   // something
   fBitmap.Free;
   fCounterBmp.Free;
   For i:=0 To 10 Do
   Begin
    NumBmp[i].Free;
   End;
   inherited;
end;
{------------------------------------------------------------------------------}
procedure TxCounter.ShowTime(mm,ss:integer);
//var i,fMin,fSec:integer;
begin

{fMin:=mm; fSec:=ss;
If fMin>99 Then fMin:=99; If fMin<0 Then fMin:=0;
If fSec>99 Then fSec:=99; If fSec<0 Then fSec:=0;

 For i:=0 To 9 Do
 Begin
  NumBmp[i].Height:=19; NumBmp[i].Width:=12;
  NumBmp[i].Canvas.CopyMode:=cmSrcCopy;
  NumBmp[i].Canvas.CopyRect(Rect(0,0,12,19),fBitmap.Canvas,Rect(i*12,0,i*12+12,19));
 End;
  NumBmp[10].Height:=19; NumBmp[10].Width:=4;
  NumBmp[10].Canvas.CopyMode:=cmSrcCopy;
  NumBmp[10].Canvas.CopyRect(Rect(0,0,4,19),fBitmap.Canvas,Rect(120,0,124,19));

fCounterBmp.Canvas.CopyMode:=cmSrcCopy;
fCounterBmp.Canvas.Draw(0,0,NumBmp[fMin div 10]);
fCounterBmp.Canvas.Draw(12,0,NumBmp[fMin mod 10]);
fCounterBmp.Canvas.Draw(24,0,NumBmp[10]);
fCounterBmp.Canvas.Draw(28,0,NumBmp[fSec div 10]);
fCounterBmp.Canvas.Draw(40,0,NumBmp[fSec mod 10]);}

fMM:=mm; fSS:=ss; Paint;
end;
{------------------------------------------------------------------------------}
procedure TxCounter.Paint;
var i,fMin,fSec:integer;
begin

fMin:=fmm; fSec:=fss;
If fMin>99 Then fMin:=99; If fMin<0 Then fMin:=0;
If fSec>99 Then fSec:=99; If fSec<0 Then fSec:=0;

 For i:=0 To 9 Do
 Begin
  NumBmp[i].Height:=19; NumBmp[i].Width:=12;
  NumBmp[i].Canvas.CopyMode:=cmSrcCopy;
  NumBmp[i].Canvas.CopyRect(Rect(0,0,12,19),fBitmap.Canvas,Rect(i*12,0,i*12+12,19));
 End;
  NumBmp[10].Height:=19; NumBmp[10].Width:=4;
  NumBmp[10].Canvas.CopyMode:=cmSrcCopy;
  NumBmp[10].Canvas.CopyRect(Rect(0,0,4,19),fBitmap.Canvas,Rect(120,0,124,19));

 fCounterBmp.Canvas.CopyMode:=cmSrcCopy;
 fCounterBmp.Canvas.Draw(0,0,NumBmp[fMin div 10]);
 fCounterBmp.Canvas.Draw(12,0,NumBmp[fMin mod 10]);
 fCounterBmp.Canvas.Draw(24,0,NumBmp[10]);
 fCounterBmp.Canvas.Draw(28,0,NumBmp[fSec div 10]);
 fCounterBmp.Canvas.Draw(40,0,NumBmp[fSec mod 10]);

 Canvas.CopyMode:=cmSrcCopy;
 Canvas.StretchDraw(Rect(0,0,ClientWidth,ClientHeight),fCounterBmp);
end;
{------------------------------------------------------------------------------}
procedure TxCounter.SetBitmap(bmp:TBitmap);
begin
 fBitmap.Assign(bmp);
end;
{------------------------------------------------------------------------------}
procedure Register;
begin
 RegisterComponents('XRat', [TxCounter]);
end;
{------------------------------------------------------------------------------}
end.
