unit xLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Extctrls, xGraphLib;

type
  TxLabel = class(TGraphicControl)
  private
    fText:string;
    fBitmap:TBitmap;
    fFont:TFont;
    fScroll:boolean;
    fColor:TColor;
    fTimer:TTimer;
    fTextShift:integer;
    procedure SetText(S:String);
    procedure SetFont(F:TFont);
    procedure SetScroll(B:Boolean);
    procedure SetColor(C:TColor);
    procedure OnTimer(Sender:TObject);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
  published
    procedure PaintText;
    property Text: String read fText write SetText;
    property Font: TFont read fFont write SetFont;
    property Color: TColor read fColor write SetColor;
    property Autoscroll: boolean read fScroll write SetScroll;
    property Hint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
  end;

procedure Register;

implementation
{------------------------------------------------------------------------------}
constructor TxLabel.Create(AOwner:TComponent);
begin
   inherited;
   Width:=100; Height:=20;

   fBitmap:=TBitmap.Create;

   fColor:=clLime; fText:='Text'; fFont:=TFont.Create; fFont.Name:='Arial';
   fFont.Size:=8; fScroll:=False;

   fTimer:=TTimer.Create(Self); fTimer.Interval:=50; fTimer.Enabled:=False;
   fTextShift:=0; fScroll:=False;
   fTimer.OnTimer:=OnTimer;
end;
{------------------------------------------------------------------------------}
destructor TxLabel.Destroy;
begin
   fFont.Free; fTimer.Free; fBitmap.Free;
   inherited;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.Paint;
//var B:TBitmap;
begin
{B:=TBitmap.Create; B.Width:=Width; B.Height:=Height;
B.Canvas.Brush.Color:=clBlack; B.Canvas.CopyMode:=cmSrcCopy;

If (not (csDesigning in ComponentState)) and
   (not (csLoading in ComponentState))
Then CopyParentImage(Self,B.Canvas);

B.Canvas.Draw(0,0,fBitmap);} Canvas.CopyMode:=cmSrcCopy; Canvas.Draw(0,0,{B}fBitmap);
//B.Free;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.PaintText;
var txtWidth:integer;
    txtWidthWide:integer;
begin
fBitmap.Width:=Width; fBitmap.Canvas.Font.Assign(fFont); fBitmap.Canvas.Font.Color:=fColor;
{If fColor=clBlack
Then fBitmap.Canvas.Brush.Color:=clWhite}
{Else} fBitmap.Canvas.Brush.Color:=clBlack;
//fBitmap.TransparentMode:=tmAuto; fBitmap.Transparent:=True;
Height:=fBitmap.Canvas.TextHeight('X'); fBitmap.Height:=Height;
fBitmap.Canvas.FillRect(Rect(0,0,Width,Height));
txtWidth:=fBitmap.Canvas.TextWidth(fText); txtWidthWide:=fBitmap.Canvas.TextWidth(fText+'  +++  ');

If fScroll and (txtWidth>Width)
Then Begin
 fBitmap.Canvas.TextOut(0-fTextShift,0,fText+'  +++  ');
 fBitmap.Canvas.TextOut(txtWidthWide-fTextShift,0,fText+'  +++  ');
End
Else Begin
 fBitmap.Canvas.TextOut(0,0,fText);
End;
Paint;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.OnTimer(Sender:TObject);
var txtWidth:integer;
begin
 Canvas.Font.Assign(fFont); txtWidth:=Canvas.TextWidth(fText+'  +++  ');
 fTextShift:=fTextShift+1; If fTextShift>txtWidth Then fTextShift:=0;
 PaintText;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.SetText(S:String);
begin
 If fText=S Then exit; fText:=S; PaintText;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.SetFont(F:TFont);
begin
 fFont.Assign(F); PaintText;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.SetColor(C:TColor);
begin
 fColor:=C; PaintText;
end;
{------------------------------------------------------------------------------}
procedure TxLabel.SetScroll(B:Boolean);
begin
 fScroll:=b; fTimer.Enabled:=b;
end;
{------------------------------------------------------------------------------}
procedure Register;
begin
 RegisterComponents('XRat', [TxLabel]);
end;
{------------------------------------------------------------------------------}
end.
