unit XaudioPlayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
{ Messages }
  XA_MSG_BASE                                        = $9000;
  XA_MSG_UNKNOWN                                     =   0;
  XA_MSG_COMMAND_EXIT                                =   1;
  XA_MSG_COMMAND_SYNC                                =   2;
  XA_MSG_COMMAND_PING                                =   3;
  XA_MSG_COMMAND_PLAY                                =   4;
  XA_MSG_COMMAND_PAUSE                               =   5;
  XA_MSG_COMMAND_STOP                                =   6;
  XA_MSG_COMMAND_SEEK                                =   7;
  XA_MSG_COMMAND_INPUT_OPEN                          =   8;
  XA_MSG_COMMAND_INPUT_CLOSE                         =   9;
  XA_MSG_COMMAND_INPUT_SEND_MESSAGE                  =  10;
  XA_MSG_COMMAND_INPUT_ADD_FILTER                    =  11;
  XA_MSG_COMMAND_INPUT_REMOVE_FILTER                 =  12;
  XA_MSG_COMMAND_INPUT_FILTERS_LIST                  =  13;
  XA_MSG_COMMAND_INPUT_MODULE_REGISTER               =  14;
  XA_MSG_COMMAND_INPUT_MODULE_QUERY                  =  15;
  XA_MSG_COMMAND_INPUT_MODULES_LIST                  =  16;
  XA_MSG_COMMAND_OUTPUT_OPEN                         =  17;
  XA_MSG_COMMAND_OUTPUT_CLOSE                        =  18;
  XA_MSG_COMMAND_OUTPUT_SEND_MESSAGE                 =  19;
  XA_MSG_COMMAND_OUTPUT_MUTE                         =  20;
  XA_MSG_COMMAND_OUTPUT_UNMUTE                       =  21;
  XA_MSG_COMMAND_OUTPUT_RESET                        =  22;
  XA_MSG_COMMAND_OUTPUT_DRAIN                        =  23;
  XA_MSG_COMMAND_OUTPUT_ADD_FILTER                   =  24;
  XA_MSG_COMMAND_OUTPUT_REMOVE_FILTER                =  25;
  XA_MSG_COMMAND_OUTPUT_FILTERS_LIST                 =  26;
  XA_MSG_COMMAND_OUTPUT_MODULE_REGISTER              =  27;
  XA_MSG_COMMAND_OUTPUT_MODULE_QUERY                 =  28;
  XA_MSG_COMMAND_OUTPUT_MODULES_LIST                 =  29;
  XA_MSG_COMMAND_CODEC_SEND_MESSAGE                  =  30;
  XA_MSG_COMMAND_CODEC_MODULE_REGISTER               =  31;
  XA_MSG_COMMAND_CODEC_MODULE_QUERY                  =  32;
  XA_MSG_COMMAND_CODEC_MODULES_LIST                  =  33;
  XA_MSG_SET_PLAYER_MODE                             =  34;
  XA_MSG_GET_PLAYER_MODE                             =  35;
  XA_MSG_SET_PLAYER_ENVIRONMENT_INTEGER              =  36;
  XA_MSG_GET_PLAYER_ENVIRONMENT_INTEGER              =  37;
  XA_MSG_SET_PLAYER_ENVIRONMENT_STRING               =  38;
  XA_MSG_GET_PLAYER_ENVIRONMENT_STRING               =  39;
  XA_MSG_UNSET_PLAYER_ENVIRONMENT                    =  40;
  XA_MSG_SET_INPUT_NAME                              =  41;
  XA_MSG_GET_INPUT_NAME                              =  42;
  XA_MSG_SET_INPUT_MODULE                            =  43;
  XA_MSG_GET_INPUT_MODULE                            =  44;
  XA_MSG_SET_INPUT_POSITION_RANGE                    =  45;
  XA_MSG_GET_INPUT_POSITION_RANGE                    =  46;
  XA_MSG_SET_INPUT_TIMECODE_GRANULARITY              =  47;
  XA_MSG_GET_INPUT_TIMECODE_GRANULARITY              =  48;
  XA_MSG_SET_OUTPUT_NAME                             =  49;
  XA_MSG_GET_OUTPUT_NAME                             =  50;
  XA_MSG_SET_OUTPUT_MODULE                           =  51;
  XA_MSG_GET_OUTPUT_MODULE                           =  52;
  XA_MSG_SET_OUTPUT_POSITION_RANGE                   =  53;
  XA_MSG_GET_OUTPUT_POSITION_RANGE                   =  54;
  XA_MSG_SET_OUTPUT_TIMECODE_GRANULARITY             =  55;
  XA_MSG_GET_OUTPUT_TIMECODE_GRANULARITY             =  56;
  XA_MSG_SET_OUTPUT_VOLUME                           =  57;
  XA_MSG_GET_OUTPUT_VOLUME                           =  58;
  XA_MSG_SET_OUTPUT_CHANNELS                         =  59;
  XA_MSG_GET_OUTPUT_CHANNELS                         =  60;
  XA_MSG_SET_OUTPUT_PORTS                            =  61;
  XA_MSG_GET_OUTPUT_PORTS                            =  62;
  XA_MSG_SET_CODEC_QUALITY                           =  63;
  XA_MSG_GET_CODEC_QUALITY                           =  64;
  XA_MSG_SET_CODEC_EQUALIZER                         =  65;
  XA_MSG_GET_CODEC_EQUALIZER                         =  66;
  XA_MSG_SET_CODEC_MODULE                            =  67;
  XA_MSG_GET_CODEC_MODULE                            =  68;
  XA_MSG_SET_NOTIFICATION_MASK                       =  69;
  XA_MSG_GET_NOTIFICATION_MASK                       =  70;
  XA_MSG_SET_DEBUG_LEVEL                             =  71;
  XA_MSG_GET_DEBUG_LEVEL                             =  72;
  XA_MSG_NOTIFY_READY                                =  73;
  XA_MSG_NOTIFY_ACK                                  =  74;
  XA_MSG_NOTIFY_NACK                                 =  75;
  XA_MSG_NOTIFY_PONG                                 =  76;
  XA_MSG_NOTIFY_EXITED                               =  77;
  XA_MSG_NOTIFY_PLAYER_STATE                         =  78;
  XA_MSG_NOTIFY_PLAYER_MODE                          =  79;
  XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_INTEGER           =  80;
  XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_STRING            =  81;
  XA_MSG_NOTIFY_INPUT_STATE                          =  82;
  XA_MSG_NOTIFY_INPUT_NAME                           =  83;
  XA_MSG_NOTIFY_INPUT_CAPS                           =  84;
  XA_MSG_NOTIFY_INPUT_POSITION                       =  85;
  XA_MSG_NOTIFY_INPUT_POSITION_RANGE                 =  86;
  XA_MSG_NOTIFY_INPUT_TIMECODE                       =  87;
  XA_MSG_NOTIFY_INPUT_TIMECODE_GRANULARITY           =  88;
  XA_MSG_NOTIFY_INPUT_MODULE                         =  89;
  XA_MSG_NOTIFY_INPUT_MODULE_INFO                    =  90;
  XA_MSG_NOTIFY_INPUT_DEVICE_INFO                    =  91;
  XA_MSG_NOTIFY_INPUT_FILTER_INFO                    =  92;
  XA_MSG_NOTIFY_OUTPUT_STATE                         =  93;
  XA_MSG_NOTIFY_OUTPUT_NAME                          =  94;
  XA_MSG_NOTIFY_OUTPUT_CAPS                          =  95;
  XA_MSG_NOTIFY_OUTPUT_POSITION                      =  96;
  XA_MSG_NOTIFY_OUTPUT_POSITION_RANGE                =  97;
  XA_MSG_NOTIFY_OUTPUT_TIMECODE                      =  98;
  XA_MSG_NOTIFY_OUTPUT_TIMECODE_GRANULARITY          =  99;
  XA_MSG_NOTIFY_OUTPUT_VOLUME                        = 100;
  XA_MSG_NOTIFY_OUTPUT_BALANCE                       = 101;
  XA_MSG_NOTIFY_OUTPUT_PCM_LEVEL                     = 102;
  XA_MSG_NOTIFY_OUTPUT_MASTER_LEVEL                  = 103;
  XA_MSG_NOTIFY_OUTPUT_CHANNELS                      = 104;
  XA_MSG_NOTIFY_OUTPUT_PORTS                         = 105;
  XA_MSG_NOTIFY_OUTPUT_MODULE                        = 106;
  XA_MSG_NOTIFY_OUTPUT_MODULE_INFO                   = 107;
  XA_MSG_NOTIFY_OUTPUT_DEVICE_INFO                   = 108;
  XA_MSG_NOTIFY_OUTPUT_FILTER_INFO                   = 109;
  XA_MSG_NOTIFY_STREAM_MIME_TYPE                     = 110;
  XA_MSG_NOTIFY_STREAM_DURATION                      = 111;
  XA_MSG_NOTIFY_STREAM_PARAMETERS                    = 112;
  XA_MSG_NOTIFY_STREAM_PROPERTIES                    = 113;
  XA_MSG_NOTIFY_CODEC_QUALITY                        = 114;
  XA_MSG_NOTIFY_CODEC_EQUALIZER                      = 115;
  XA_MSG_NOTIFY_CODEC_MODULE                         = 116;
  XA_MSG_NOTIFY_CODEC_MODULE_INFO                    = 117;
  XA_MSG_NOTIFY_CODEC_DEVICE_INFO                    = 118;
  XA_MSG_NOTIFY_NOTIFICATION_MASK                    = 119;
  XA_MSG_NOTIFY_DEBUG_LEVEL                          = 120;
  XA_MSG_NOTIFY_PROGRESS                             = 121;
  XA_MSG_NOTIFY_DEBUG                                = 122;
  XA_MSG_NOTIFY_ERROR                                = 123;
  XA_MSG_NOTIFY_PRIVATE_DATA                         = 124;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_MODULE_REGISTER    = 125;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_MODULE_QUERY       = 126;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_MODULES_LIST       = 127;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_EXIT               = 128;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_START              = 129;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_STOP               = 130;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_PAUSE              = 131;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_RESTART            = 132;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_FLUSH              = 133;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_SEND_MESSAGE       = 134;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_QUEUE_AUDIO_EVENT  = 135;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_QUEUE_TAG_EVENT    = 136;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_QUEUE_TIMECODE_EVENT = 137;
  XA_MSG_COMMAND_FEEDBACK_HANDLER_QUEUE_POSITION_EVENT = 138;
  XA_MSG_SET_FEEDBACK_AUDIO_EVENT_RATE               = 139;
  XA_MSG_GET_FEEDBACK_AUDIO_EVENT_RATE               = 140;
  XA_MSG_SET_FEEDBACK_HANDLER_NAME                   = 141;
  XA_MSG_GET_FEEDBACK_HANDLER_NAME                   = 142;
  XA_MSG_SET_FEEDBACK_HANDLER_MODULE                 = 143;
  XA_MSG_GET_FEEDBACK_HANDLER_MODULE                 = 144;
  XA_MSG_SET_FEEDBACK_HANDLER_ENVIRONMENT_INTEGER    = 145;
  XA_MSG_GET_FEEDBACK_HANDLER_ENVIRONMENT_INTEGER    = 146;
  XA_MSG_SET_FEEDBACK_HANDLER_ENVIRONMENT_STRING     = 147;
  XA_MSG_GET_FEEDBACK_HANDLER_ENVIRONMENT_STRING     = 148;
  XA_MSG_UNSET_FEEDBACK_HANDLER_ENVIRONMENT          = 149;
  XA_MSG_NOTIFY_FEEDBACK_AUDIO_EVENT_RATE            = 150;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_STATE               = 151;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_MODULE              = 152;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_MODULE_INFO         = 153;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_NAME                = 154;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_INFO                = 155;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_ENVIRONMENT_INTEGER = 156;
  XA_MSG_NOTIFY_FEEDBACK_HANDLER_ENVIRONMENT_STRING  = 157;
  XA_MSG_NOTIFY_FEEDBACK_AUDIO_EVENT                 = 158;
  XA_MSG_NOTIFY_FEEDBACK_TAG_EVENT                   = 159;
  XA_MSG_LAST                                        = 160;

{ Player State }
  XA_PLAYER_STATE_STOPPED                  = 0;
  XA_PLAYER_STATE_PLAYING                  = 1;
  XA_PLAYER_STATE_PAUSED                   = 2;
  XA_PLAYER_STATE_EOF                      = 3;

{ Input State }
  XA_INPUT_STATE_OPEN                      = 0;
  XA_INPUT_STATE_CLOSED                    = 1;

{ Output State }
  XA_OUTPUT_STATE_OPEN                     = 0;
  XA_OUTPUT_STATE_CLOSED                   = 1;

{ Feedback State }
  XA_FEEDBACK_STATE_STARTED                =  0;
  XA_FEEDBACK_STATE_STOPPED                =  1;

{ Channel Configurations }
  XA_OUTPUT_CHANNELS_STEREO                = 0;
  XA_OUTPUT_CHANNELS_MONO_LEFT             = 1;
  XA_OUTPUT_CHANNELS_MONO_RIGHT            = 2;
  XA_OUTPUT_CHANNELS_MONO_MIX              = 3;

{ Player Modes }
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_STOP      = 1;
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_PAUSE     = 2;
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_EOF       = 4;

{ Notification Masks }
  XA_NOTIFY_MASK_ERROR                          = $0000001;
  XA_NOTIFY_MASK_DEBUG                          = $0000002;
  XA_NOTIFY_MASK_PROGRESS                       = $0000004;
  XA_NOTIFY_MASK_ACK                            = $0000008;
  XA_NOTIFY_MASK_NACK                           = $0000010;
  XA_NOTIFY_MASK_PLAYER_STATE                   = $0000020;
  XA_NOTIFY_MASK_INPUT_STATE                    = $0000040;
  XA_NOTIFY_MASK_INPUT_NAME                     = $0000080;
  XA_NOTIFY_MASK_INPUT_CAPS                     = $0000100;
  XA_NOTIFY_MASK_INPUT_POSITION                 = $0000200;
  XA_NOTIFY_MASK_INPUT_POSITION_RANGE           = $0000400;
  XA_NOTIFY_MASK_INPUT_TIMECODE                 = $0000800;
  XA_NOTIFY_MASK_INPUT_TIMECODE_GRANULARITY     = $0001000;
  XA_NOTIFY_MASK_OUTPUT_STATE                   = $0002000;
  XA_NOTIFY_MASK_OUTPUT_NAME                    = $0004000;
  XA_NOTIFY_MASK_OUTPUT_CAPS                    = $0008000;
  XA_NOTIFY_MASK_OUTPUT_VOLUME                  = $0010000;
  XA_NOTIFY_MASK_OUTPUT_BALANCE                 = $0020000;
  XA_NOTIFY_MASK_OUTPUT_PCM_LEVEL               = $0040000;
  XA_NOTIFY_MASK_OUTPUT_MASTER_LEVEL            = $0080000;
  XA_NOTIFY_MASK_OUTPUT_PORTS                   = $0100000;
  XA_NOTIFY_MASK_STREAM_MIME_TYPE               = $0200000;
  XA_NOTIFY_MASK_STREAM_DURATION                = $0400000;
  XA_NOTIFY_MASK_STREAM_PARAMETERS              = $0800000;
  XA_NOTIFY_MASK_STREAM_PROPERTIES              = $1000000;
  XA_NOTIFY_MASK_CODEC_EQUALIZER                = $2000000;
  XA_NOTIFY_MASK_FEEDBACK_EVENT                 = $4000000;

{ Input Caps }
  XA_DECODER_INPUT_SEEKABLE                  = $0001;

{ Output Caps }
  XA_DECODER_DEVICE_HAS_MASTER_LEVEL_CONTROL = $0000001;
  XA_DECODER_DEVICE_HAS_PCM_LEVEL_CONTROL    = $0000002;
  XA_DECODER_DEVICE_HAS_BALANCE_CONTROL      = $0000004;
  XA_DECODER_DEVICE_HAS_LINE_OUT             = $0000008;
  XA_DECODER_DEVICE_HAS_SPEAKER_OUT          = $0000010;
  XA_DECODER_DEVICE_HAS_HEADPHONE_OUT        = $0000020;
  XA_DECODER_DEVICE_HAS_MONO_16_00_KHZ       = $0000080;
  XA_DECODER_DEVICE_HAS_MONO_22_05_KHZ       = $0000100;
  XA_DECODER_DEVICE_HAS_MONO_24_00_KHZ       = $0000200;
  XA_DECODER_DEVICE_HAS_MONO_32_00_KHZ       = $0000400;
  XA_DECODER_DEVICE_HAS_MONO_44_10_KHZ       = $0000800;
  XA_DECODER_DEVICE_HAS_MONO_48_00_KHZ       = $0001000;
  XA_DECODER_DEVICE_HAS_STEREO_16_00_KHZ     = $0002000;
  XA_DECODER_DEVICE_HAS_STEREO_22_05_KHZ     = $0004000;
  XA_DECODER_DEVICE_HAS_STEREO_24_00_KHZ     = $0008000;
  XA_DECODER_DEVICE_HAS_STEREO_32_00_KHZ     = $0010000;
  XA_DECODER_DEVICE_HAS_STEREO_44_10_KHZ     = $0020000;
  XA_DECODER_DEVICE_HAS_STEREO_48_00_KHZ     = $0040000;
  XA_DECODER_DEVICE_HAS_8_BITS               = $0080000;
  XA_DECODER_DEVICE_HAS_MU_LAW               = $0100000;
  XA_DECODER_DEVICE_HAS_16_BITS              = $0200000;
  XA_DECODER_DEVICE_HAS_MUTE                 = $0400000;
  XA_DECODER_DEVICE_HAS_RESET                = $0800000;
  XA_DECODER_DEVICE_HAS_PAUSE                = $1000000;
  XA_DECODER_DEVICE_HAS_DRAIN                = $2000000;
  XA_DECODER_DEVICE_HAS_BUFFER_STATUS        = $4000000;

{ Output Ports }
  XA_DECODER_CONTROL_OUTPUT_LINE             = $01;
  XA_DECODER_CONTROL_OUTPUT_SPEAKER          = $02;
  XA_DECODER_CONTROL_OUTPUT_HEADPHONE        = $04;

{ Environment Variables }
  XA_DECODER_ENVIRONMENT_MAX_NAME_LENGTH     = 256;
  XA_DECODER_ENVIRONMENT_MAX_STRING_LENGTH   = 1024;

{ Input Device Flags }
  XA_DECODER_INPUT_QUERY_NAME_IS_GENERIC     = $01;
  XA_DECODER_INPUT_QUERY_DEVICE_IS_DEFAULT   = $02;

{ Output Device Flags }
  XA_DECODER_OUTPUT_QUERY_NAME_IS_GENERIC     = $01;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_DEFAULT   = $02;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_SHAREABLE = $04;

{ Modules }
  XA_DECODER_INPUT_AUTOSELECT              = -1;
  XA_DECODER_OUTPUT_AUTOSELECT             = -1;

{ Filters }
  XA_DECODER_INPUT_FILTER_FIRST            = -1;
  XA_DECODER_INPUT_FILTER_LAST             =  0;
  XA_DECODER_INPUT_FILTER_BY_NAME          = -2;

  XA_DECODER_OUTPUT_FILTER_FIRST           = -1;
  XA_DECODER_OUTPUT_FILTER_LAST            =  0;
  XA_DECODER_OUTPUT_FILTER_BY_NAME         = -2;

{ Priorities }
  XA_CONTROL_PRIORITY_LOWEST               = 0;
  XA_CONTROL_PRIORITY_LOW                  = 1;
  XA_CONTROL_PRIORITY_NORMAL               = 2;
  XA_CONTROL_PRIORITY_HIGH                 = 3;
  XA_CONTROL_PRIORITY_HIGHEST              = 4;

  XA_DECODER_CODEC_QUALITY_HIGH            = 0;
  XA_DECODER_CODEC_QUALITY_MEDIUM          = 1;
  XA_DECODER_CODEC_QUALITY_LOW             = 2;

{ Property Types }
  XA_PROPERTY_TYPE_STRING                  = 0;
  XA_PROPERTY_TYPE_INTEGER                 = 1;

{ API Ids }
  XA_VERSION_ID_SYNC_API       = 1;
  XA_VERSION_ID_ASYNC_API      = 2;
  XA_VERSION_ID_IMPLEMENTATION = 3;

{ Misc Constants }
  XA_OUTPUT_VOLUME_IGNORE_FIELD            = -1;
  XA_DECODER_MAX_NAME_LENGTH               = 255;
  XA_DECODER_MAX_DESCRIPTION_LENGTH        = 255;

{ API Version }
  XA_ASYNC_API_MAJOR = 3;
  XA_ASYNC_API_MINOR = 8;

{ Types }
type
  XA_EnvironmentInfo = record
    name: PChar;
    case Integer of
      0: (integer_value: LongInt);
      1: (string_value:  PChar);
  end;

  XA_TimecodeInfo = record
    h: Byte;
    m: Byte;
    s: Byte;
    f: Byte;
  end;

  XA_NackInfo = record
    command: Byte;
    code:    SmallInt;
  end;

  XA_VolumeInfo = record
    master_level: ShortInt;
    pcm_level:    ShortInt;
    balance:      ShortInt;
  end;

  XA_PositionInfo = record
    offset: Cardinal;
    range:  Cardinal;
  end;

  XA_ModuleInfo = record
    id:          Byte;
    nb_devices:  Byte;
    name:        PChar;
    description: PChar;
  end;

  XA_FilterInfo = record
    name: PChar;
    id:   Word;
  end;

  XA_DeviceInfo = record
    module_id:   Byte;
    index:       Byte;
    flags:       Byte;
    name:        PChar;
    description: PChar;
  end;

  XA_StreamParameters = record
    frequency:   Cardinal;
    bitrate:     SmallInt;
    nb_channels: Byte;
  end;

  XA_ModuleMessage = record
    message_type: Word;
    size:         Cardinal;
    data:         Pointer;
  end;

  XA_ProgressInfo = record
    source:  Byte;
    code:    Byte;
    value:   SmallInt;
    msg:     PChar;
  end;

  XA_DebugInfo = record
    source:  Byte;
    level:   Byte;
    msg:     PChar;
  end;

  XA_ErrorInfo = record
    source: Byte;
    code:   SmallInt;
    msg:    PChar;
  end;

  XA_EqualizerInfo = record
    left:  array[0..31] of ShortInt;
    right: array[0..31] of ShortInt;
  end;
  PXA_EqualizerInfo = ^XA_EqualizerInfo;

  XA_PrivateData = record
    source:    Byte;
    data_type: SmallInt;
    data:      Pointer;
    size:      Cardinal;
  end;

  XA_AbsoluteTime = record
    seconds:      Cardinal;
    microseconds: Cardinal;
  end;

  XA_TagEvent = record
    when: XA_AbsoluteTime;
    tag:  Cardinal;
  end;

  XA_AudioEvent = record
    when:               XA_AbsoluteTime;
    sampling_frequency: Cardinal;
    nb_channels:        Word;
    nb_samples:         Word;
    samples:            Pointer;
  end;

  XA_Property = record
    name:       PChar;
    value_type: Integer;
    case Integer of
      0: (integer_value: LongInt);
      1: (string_value:  PChar);
  end;

  PXA_Property = ^XA_Property;

  XA_PropertyList = record
    nb_properties: Cardinal;
    properties:    PXA_Property;
  end;

  XA_Message = record
    code: Integer;
    case Integer of
      0:  (buffer:            Pchar);
      1:  (name:              PChar);
      2:  (mime_type:         PChar);
      3:  (module_id:         SmallInt);
      4:  (state:             Byte);
      5:  (mode:              Cardinal);
      6:  (channels:          Byte);
      7:  (quality:           Byte);
      8:  (duration:          Cardinal);
      9:  (range:             Cardinal);
      10:  (granularity:       Cardinal);
      11: (caps:              Cardinal);
      12: (ports:             Byte);
      13: (ack:               Byte);
      14: (tag:               Cardinal);
      15: (debug_level:       Byte);
      16: (notification_mask: Cardinal);
      17: (rate:              Byte);
      18: (nack:              XA_NackInfo);
      19: (volume:            XA_VolumeInfo);
      20: (position:          XA_PositionInfo);
      21: (equalizer:        ^XA_EqualizerInfo);
      22: (module_info:       XA_ModuleInfo);
      23: (filter_info:       XA_FilterInfo);
      24: (device_info:       XA_DeviceInfo);
      25: (stream_parameters: XA_StreamParameters);
      26: (environment_info:  XA_EnvironmentInfo);
      27: (timecode:          XA_TimecodeInfo);
      28: (module_message:    XA_ModuleMessage);
      29: (tag_event:         XA_TagEvent);
      30: (audio_event:       XA_AudioEvent);
      31: (properties:        XA_PropertyList);
      32: (when:              XA_AbsoluteTime);
      33: (private_data:      XA_PrivateData);
      34: (progress:          XA_ProgressInfo);
      35: (debug:             XA_DebugInfo);
      36: (error:             XA_ErrorInfo);
  end;

{ Misc }
  TXaudioPlayer = class;
  EXaudioException = class(Exception);

{ Notification Functions }
  TNotifyMessageEvent                  = procedure(Sender: TXaudioPlayer; var Msg: XA_Message) of object;
  TNotifyAckEvent                      = procedure(Sender: TXaudioPlayer; Command: Byte) of object;
  TNotifyNackEvent                     = procedure(Sender: TXaudioPlayer; Command: Byte; Code: SmallInt) of object;
  TNotifyPongEvent                     = procedure(Sender: TXaudioPlayer; Tag: Cardinal) of object;
  TNotifyPlayerStateEvent              = procedure(Sender: TXaudioPlayer; State: Integer) of object;
  TNotifyPlayerModeEvent               = procedure(Sender: TXaudioPlayer; Mode: Integer) of object;
  TNotifyEnvironmentIntegerEvent       = procedure(Sender: TXaudioPlayer; const Name: String; Value: Integer) of object;
  TNotifyEnvironmentStringEvent        = procedure(Sender: TXaudioPlayer; const Name: String; const Value: String) of object;
  TNotifyInputStateEvent               = procedure(Sender: TXaudioPlayer; State: Integer) of object;
  TNotifyInputNameEvent                = procedure(Sender: TXaudioPlayer; const Name: String) of object;
  TNotifyInputCapsEvent                = procedure(Sender: TXaudioPlayer; Caps: Cardinal) of object;
  TNotifyInputPositionEvent            = procedure(Sender: TXaudioPlayer; Offset: Cardinal; Range: Cardinal) of object;
  TNotifyInputPositionRangeEvent       = procedure(Sender: TXaudioPlayer; Range: Integer) of object;
  TNotifyInputTimecodeEvent            = procedure(Sender: TXaudioPlayer; Hours: Byte; Minutes: Byte; Seconds: Byte; Fractions: Byte) of object;
  TNotifyInputTimecodeGranularityEvent = procedure(Sender: TXaudioPlayer; Granularity: Cardinal) of object;
  TNotifyInputModuleEvent              = procedure(Sender: TXaudioPlayer; ID: SmallInt) of object;
  TNotifyInputModuleInfoEvent          = procedure(Sender: TXaudioPlayer; ID: Byte; NbDevices: Byte; const Name: String; const Description: String) of object;
  TNotifyInputDeviceInfoEvent          = procedure(Sender: TXaudioPlayer; ModuleID: Byte; Index: Byte; Flags: Byte; const Name: String; const Description: String) of object;
  TNotifyInputFilterInfoEvent          = procedure(Sender: TXaudioPlayer; ID: Byte; const Name: String) of object;
  TNotifyOutputStateEvent              = procedure(Sender: TXaudioPlayer; State: Integer) of object;
  TNotifyOutputNameEvent               = procedure(Sender: TXaudioPlayer; const Name: String) of object;
  TNotifyOutputCapsEvent               = procedure(Sender: TXaudioPlayer; Caps: Cardinal) of object;
  TNotifyOutputVolumeEvent             = procedure(Sender: TXaudioPlayer; MasterLevel: Byte; PcmLevel: Byte; Balance: Byte) of object;
  TNotifyOutputBalanceEvent            = procedure(Sender: TXaudioPlayer; Balance: Byte) of object;
  TNotifyOutputPcmLevelEvent           = procedure(Sender: TXaudioPlayer; PcmLevel: Byte) of object;
  TNotifyOutputMasterLevelEvent        = procedure(Sender: TXaudioPlayer; MasterLevel: Byte) of object;
  TNotifyOutputChannelsEvent           = procedure(Sender: TXaudioPlayer; Channels: Byte) of object;
  TNotifyOutputPortsEvent              = procedure(Sender: TXaudioPlayer; Ports: Cardinal) of object;
  TNotifyOutputModuleEvent             = procedure(Sender: TXaudioPlayer; ID: SmallInt) of object;
  TNotifyOutputModuleInfoEvent         = procedure(Sender: TXaudioPlayer; ID: Byte; NbDevices: Byte; const Name: String; const Description: String) of object;
  TNotifyOutputDeviceInfoEvent         = procedure(Sender: TXaudioPlayer; ModuleID: Byte; Index: Byte; Flags: Byte; const Name: String; const Description: String) of object;
  TNotifyOutputFilterInfoEvent         = procedure(Sender: TXaudioPlayer; ID: Byte; const Name: String) of object;
  TNotifyStreamMimeTypeEvent           = procedure(Sender: TXaudioPlayer; MimeType: String) of object;
  TNotifyStreamDurationEvent           = procedure(Sender: TXaudioPlayer; Duration: Cardinal) of object;
  TNotifyStreamParametersEvent         = procedure(Sender: TXaudioPlayer; Frequency: Cardinal; Bitrate: SmallInt; NbChannels: Byte) of object;
  TNotifyStreamPropertiesEvent         = procedure(Sender: TXaudioPlayer; NbProperties: Cardinal; Properties: PXA_Property) of object;
  TNotifyCodecModuleEvent              = procedure(Sender: TXaudioPlayer; ID: SmallInt) of object;
  TNotifyCodecModuleInfoEvent          = procedure(Sender: TXaudioPlayer; ID: Byte; NbDevices: Byte; const Name: String; const Description: String) of object;
  TNotifyCodecDeviceInfoEvent          = procedure(Sender: TXaudioPlayer; ModuleID: Byte; Index: Byte; Flags: Byte; const Name: String; const Description: String) of object;
  TNotifyCodecQualityEvent             = procedure(Sender: TXaudioPlayer; Quality: Byte) of object;
  TNotifyCodecEqualizerEvent           = procedure(Sender: TXaudioPlayer; var Equalizer: XA_EqualizerInfo) of object;
  TNotifyNotificationMaskEvent         = procedure(Sender: TXaudioPlayer; Mask: Cardinal) of object;
  TNotifyDebugLevelEvent               = procedure(Sender: TXaudioPlayer; Level: Byte) of object;
  TNotifyProgressEvent                 = procedure(Sender: TXaudioPlayer; Source: Byte; Code: Byte; Value: SmallInt; const Msg: String) of object;
  TNotifyDebugEvent                    = procedure(Sender: TXaudioPlayer; Source: Byte; Level: Byte; const Msg: String) of object;
  TNotifyErrorEvent                    = procedure(Sender: TXaudioPlayer; Source: Byte; Code: SmallInt; const Msg: String) of object;

{ DLL entry points }
  TPlayerNew                   = function(var Player: Pointer; var Args: HWND): Integer; stdcall;
  TPlayerDelete                = function(Player: Pointer): Integer; stdcall;
  TPlayerSetPriority           = function(Player: Pointer; Priority: Cardinal): Integer; stdcall;
  TPlayerGetPriority           = function(Player: Pointer): Integer; stdcall;
  TXaudioErrorString           = function(Code: Integer): PChar; stdcall;
  TXaudioGetVersion            = function(VersionIndex: Integer): Cardinal; stdcall;
  TControlMessageSend_N        = function(Player: Pointer; Code: Integer): Integer; stdcall;
  TControlMessageSend_P        = function(Player: Pointer; Code: Integer; Pointer1: Pointer): Integer; stdcall;
  TControlMessageSend_S        = function(Player: Pointer; Code: Integer; Str1: PChar): Integer; stdcall;
  TControlMessageSend_SS       = function(Player: Pointer; Code: Integer; Str1, Str2: PChar): Integer; stdcall;
  TControlMessageSend_SI       = function(Player: Pointer; Code: Integer; Str1: PChar; Int1: Integer): Integer; stdcall;
  TControlMessageSend_IPI      = function(Player: Pointer; Code: Integer; Int1: Integer; Ptr1: Pointer; Int2: Integer): Integer; stdcall;
  TControlMessageSend_I        = function(Player: Pointer; Code: Integer; Int1: Integer): Integer; stdcall;
  TControlMessageSend_II       = function(Player: Pointer; Code: Integer; Int1, Int2: Integer): Integer; stdcall;
  TControlMessageSend_III      = function(Player: Pointer; Code: Integer; Int1, Int2, Int3: Integer): Integer; stdcall;
  TControlMessageSend_IIII     = function(Player: Pointer; Code: Integer; Int1, Int2, Int3, Int4: Integer): Integer; stdcall;
  TControlWin32ParamsToMessage = function(Player: Pointer; var xa_msg: XA_Message; code: UINT; w_param: WPARAM; l_param: LPARAM): Integer; stdcall;

{ TXaudioPlayer Class }
  TXaudioPlayer = class(TComponent)
  private
    { Private declarations }
    Player:                            Pointer;
    PlayerPriority:                    Cardinal;
    HiddenWindow:                      HWND;
    LibraryHandle:                     HINST;
    LibraryPath:                       String;
    PlayerNew:                         TPlayerNew;
    PlayerDelete:                      TPlayerDelete;
    PlayerSetPriority:                 TPlayerSetPriority;
    PlayerGetPriority:                 TPlayerGetPriority;
    XaudioErrorString:                 TXaudioErrorString;
    XaudioGetVersion:                  TXaudioGetVersion;
    ControlMessageSend_N:              TControlMessageSend_N;
    ControlMessageSend_P:              TControlMessageSend_P;
    ControlMessageSend_S:              TControlMessageSend_S;
    ControlMessageSend_SS:             TControlMessageSend_SS;
    ControlMessageSend_SI:             TControlMessageSend_SI;
    ControlMessageSend_IPI:            TControlMessageSend_IPI;
    ControlMessageSend_I:              TControlMessageSend_I;
    ControlMessageSend_II:             TControlMessageSend_II;
    ControlMessageSend_III:            TControlMessageSend_III;
    ControlMessageSend_IIII:           TControlMessageSend_IIII;
    ControlWin32ParamsToMessage:       TControlWin32ParamsToMessage;
    FOnNotifyMessage:                  TNotifyMessageEvent;
    FOnNotifyReady:                    TNotifyEvent;
    FOnNotifyAck:                      TNotifyAckEvent;
    FOnNotifyNack:                     TNotifyNackEvent;
    FOnNotifyPong:                     TNotifyPongEvent;
    FOnNotifyExited:                   TNotifyEvent;
    FOnNotifyPlayerState:              TNotifyPlayerStateEvent;
    FOnNotifyPlayerMode:               TNotifyPlayerModeEvent;
    FOnNotifyPlayerEnvironmentInteger: TNotifyEnvironmentIntegerEvent;
    FOnNotifyPlayerEnvironmentString:  TNotifyEnvironmentStringEvent;
    FOnNotifyInputState:               TNotifyInputStateEvent;
    FOnNotifyInputName:                TNotifyInputNameEvent;
    FOnNotifyInputCaps:                TNotifyInputCapsEvent;
    FOnNotifyInputPosition:            TNotifyInputPositionEvent;
    FOnNotifyInputPositionRange:       TNotifyInputPositionRangeEvent;
    FOnNotifyInputTimecode:            TNotifyInputTimecodeEvent;
    FOnNotifyInputTimecodeGranularity: TNotifyInputTimecodeGranularityEvent;
    FOnNotifyInputModule:              TNotifyInputModuleEvent;
    FOnNotifyInputModuleInfo:          TNotifyInputModuleInfoEvent;
    FOnNotifyInputDeviceInfo:          TNotifyInputDeviceInfoEvent;
    FOnNotifyInputFilterInfo:          TNotifyInputFilterInfoEvent;
    FOnNotifyOutputState:              TNotifyOutputStateEvent;
    FOnNotifyOutputName:               TNotifyOutputNameEvent;
    FOnNotifyOutputCaps:               TNotifyOutputCapsEvent;
    FOnNotifyOutputVolume:             TNotifyOutputVolumeEvent;
    FOnNotifyOutputBalance:            TNotifyOutputBalanceEvent;
    FOnNotifyOutputPcmLevel:           TNotifyOutputPcmLevelEvent;
    FOnNotifyOutputMasterLevel:        TNotifyOutputMasterLevelEvent;
    FOnNotifyOutputChannels:           TNotifyOutputChannelsEvent;
    FOnNotifyOutputPorts:              TNotifyOutputPortsEvent;
    FOnNotifyOutputModule:             TNotifyOutputModuleEvent;
    FOnNotifyOutputModuleInfo:         TNotifyOutputModuleInfoEvent;
    FOnNotifyOutputDeviceInfo:         TNotifyOutputDeviceInfoEvent;
    FOnNotifyOutputFilterInfo:         TNotifyOutputFilterInfoEvent;
    FOnNotifyStreamMimeType:           TNotifyStreamMimeTypeEvent;
    FOnNotifyStreamDuration:           TNotifyStreamDurationEvent;
    FOnNotifyStreamParameters:         TNotifyStreamParametersEvent;
    FOnNotifyStreamProperties:         TNotifyStreamPropertiesEvent;
    FOnNotifyCodecModule:              TNotifyCodecModuleEvent;
    FOnNotifyCodecModuleInfo:          TNotifyCodecModuleInfoEvent;
    FOnNotifyCodecDeviceInfo:          TNotifyCodecDeviceInfoEvent;
    FOnNotifyCodecQuality:             TNotifyCodecQualityEvent;
    FOnNotifyCodecEqualizer:           TNotifyCodecEqualizerEvent;
    FOnNotifyNotificationMask:         TNotifyNotificationMaskEvent;
    FOnNotifyDebugLevel:               TNotifyDebugLevelEvent;
    FOnNotifyProgress:                 TNotifyProgressEvent;
    FOnNotifyDebug:                    TNotifyDebugEvent;
    FOnNotifyError:                    TNotifyErrorEvent;
    procedure SetPriority(Priority: Cardinal);
    function GetPriority: Cardinal;
    procedure ResetExternalInterface;
    procedure LoadExternalInterface;
    function LoadSymbol(Name: PChar): Pointer;
    function CheckPlayerInstance: Boolean;

  protected
    { Protected declarations }
    function TranslateMessage(var msg_from: TMessage; var msg_to: XA_Message): Integer;
    procedure OnWindowsMessage(var win32_msg: TMessage);

  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;

  published
    { Published declarations }
    function  Init: Boolean;
    function  ErrorString(Code: Integer): string;
    function  GetVersion(VersionId: Byte): Cardinal;
    procedure Ping(Tag: Cardinal);
    procedure Play;
    procedure Pause;
    procedure Stop;
    procedure Synchronize;
    procedure InputSeek(Offset: Cardinal; Range: Cardinal);
    procedure InputOpen(const Name: string);
    procedure InputClose;
    procedure InputSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
    procedure InputAddFilter(const Name: String; Where: Integer);
    procedure InputRemoveFilter(const Name: String; ID: Integer);
    procedure InputFilterList;
    procedure InputModuleRegister(const Name: String);
    procedure InputModuleQuery(ID: Cardinal);
    procedure InputModulesList;
    procedure OutputOpen(const Name: String);
    procedure OutputClose;
    procedure OutputMute;
    procedure OutputUnmute;
    procedure OutputReset;
    procedure OutputDrain;
    procedure OutputSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
    procedure OutputAddFilter(const Name: String; Where: Integer);
    procedure OutputRemoveFilter(const Name: String; ID: Integer);
    procedure OutputFilterList;
    procedure OutputModuleRegister(const Name: String);
    procedure OutputModuleQuery(ID: Cardinal);
    procedure OutputModulesList;
    procedure CodecSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
    procedure CodecModuleRegister(const Name: String);
    procedure CodecModuleQuery(ID: Cardinal);
    procedure CodecModulesList;
    procedure SetPlayerMode(Mode: Cardinal);
    procedure GetPlayerMode;
    procedure SetPlayerEnvironmentInteger(const Name: String; Value: Integer);
    procedure GetPlayerEnvironmentInteger(const Name: String);
    procedure SetPlayerEnvironmentString(const Name: String; const Value: String);
    procedure GetPlayerEnvironmentString(const Name: String);
    procedure UnsetPlayerEnvironment(const Name: String);
    procedure SetInputModule(ID: Cardinal);
    procedure GetInputModule;
    procedure SetInputName(const Name: String);
    procedure GetInputName;
    procedure SetInputPositionRange(Range: Cardinal);
    procedure GetInputPositionRange;
    procedure SetInputTimecodeGranularity(Granularity: Cardinal);
    procedure GetInputTimecodeGranularity;
    procedure SetOutputModule(ID: Cardinal);
    procedure GetOutputModule;
    procedure SetOutputName(const Name: String);
    procedure GetOutputName;
    procedure SetOutputVolume(Balance: Integer; PcmLevel: Integer; MasterLevel: Integer);
    procedure GetOutputVolume;
    procedure SetOutputChannels(Channels: Cardinal);
    procedure GetOutputChannels;
    procedure SetOutputPorts(Ports: Cardinal);
    procedure GetOutputPorts;
    procedure SetCodecQuality(Quality: Byte);
    procedure GetCodecQuality;
    procedure SetCodecEqualizer(Equalizer: PXA_EqualizerInfo);
    procedure GetCodecEqualizer;
    procedure SetNotificationMask(Mask: Cardinal);
    procedure GetNotificationMask;
    procedure SetDebugLevel(Level: Integer);
    procedure GetDebugLevel;
    property Priority:Cardinal read GetPriority write SetPriority;
    property XaudioPath:String read LibraryPath write LibraryPath;
    property OnNotifyMessage:TNotifyMessageEvent read FOnNotifyMessage write FOnNotifyMessage;
    property OnNotifyReady:TNotifyEvent read FOnNotifyReady write FOnNotifyReady;
    property OnNotifyAck:TNotifyAckEvent read FOnNotifyAck write FOnNotifyAck;
    property OnNotifyNack:TNotifyNackEvent read FOnNotifyNack write FOnNotifyNack;
    property OnNotifyPong:TNotifyPongEvent read FOnNotifyPong write FOnNotifyPong;
    property OnNotifyExited:TNotifyEvent read FOnNotifyExited write FOnNotifyExited;
    property OnNotifyPlayerState:TNotifyPlayerStateEvent read FOnNotifyPlayerState write FOnNotifyPlayerState;
    property OnNotifyPlayerMode:TNotifyPlayerModeEvent read FOnNotifyPlayerMode write FOnNotifyPlayerMode;
    property OnNotifyPlayerEnvironmentInteger:TNotifyEnvironmentIntegerEvent read FOnNotifyPlayerEnvironmentInteger write FOnNotifyPlayerEnvironmentInteger;
    property OnNotifyPlayerEnvironmentString:TNotifyEnvironmentStringEvent read FOnNotifyPlayerEnvironmentString write FOnNotifyPlayerEnvironmentString;
    property OnNotifyInputState:TNotifyInputStateEvent read FOnNotifyInputState write FOnNotifyInputState;
    property OnNotifyInputName:TNotifyInputNameEvent read FOnNotifyInputName write FOnNotifyInputName;
    property OnNotifyInputCaps:TNotifyInputCapsEvent read FOnNotifyInputCaps write FOnNotifyInputCaps;
    property OnNotifyInputPosition:TNotifyInputPositionEvent read FOnNotifyInputPosition write FOnNotifyInputPosition;
    property OnNotifyInputPositionRange:TNotifyInputPositionRangeEvent read FOnNotifyInputPositionRange write FOnNotifyInputPositionRange;
    property OnNotifyInputTimecode:TNotifyInputTimecodeEvent read FOnNotifyInputTimecode write FOnNotifyInputTimecode;
    property OnNotifyInputTimecodeGranularity:TNotifyInputTimecodeGranularityEvent read FOnNotifyInputTimecodeGranularity write FOnNotifyInputTimecodeGranularity;
    property OnNotifyInputModule:TNotifyInputModuleEvent read FOnNotifyInputModule write FOnNotifyInputModule;
    property OnNotifyInputModuleInfo:TNotifyInputModuleInfoEvent read FOnNotifyInputModuleInfo write FOnNotifyInputModuleInfo;
    property OnNotifyInputDeviceInfo:TNotifyInputDeviceInfoEvent read FOnNotifyInputDeviceInfo write FOnNotifyInputDeviceInfo;
    property OnNotifyInputFilterInfo:TNotifyInputFilterInfoEvent read FOnNotifyInputFilterInfo write FOnNotifyInputFilterInfo;
    property OnNotifyOutputState:TNotifyOutputStateEvent read FOnNotifyOutputState write FOnNotifyOutputState;
    property OnNotifyOutputName:TNotifyOutputNameEvent read FOnNotifyOutputName write FOnNotifyOutputName;
    property OnNotifyOutputCaps:TNotifyOutputCapsEvent read FOnNotifyOutputCaps write FOnNotifyOutputCaps;
    property OnNotifyOutputVolume:TNotifyOutputVolumeEvent read FOnNotifyOutputVolume write FOnNotifyOutputVolume;
    property OnNotifyOutputBalance:TNotifyOutputBalanceEvent read FOnNotifyOutputBalance write FOnNotifyOutputBalance;
    property OnNotifyOutputPcmLevel:TNotifyOutputPcmLevelEvent read FOnNotifyOutputPcmLevel write FOnNotifyOutputPcmLevel;
    property OnNotifyOutputMasterLevel:TNotifyOutputMasterLevelEvent read FOnNotifyOutputMasterLevel write FOnNotifyOutputMasterLevel;
    property OnNotifyOutputChannels:TNotifyOutputChannelsEvent read FOnNotifyOutputChannels write FOnNotifyOutputChannels;
    property OnNotifyOutputPorts:TNotifyOutputPortsEvent read FOnNotifyOutputPorts write FOnNotifyOutputPorts;
    property OnNotifyOutputModule:TNotifyOutputModuleEvent read FOnNotifyOutputModule write FOnNotifyOutputModule;
    property OnNotifyOutputModuleInfo:TNotifyOutputModuleInfoEvent read FOnNotifyOutputModuleInfo write FOnNotifyOutputModuleInfo;
    property OnNotifyOutputDeviceInfo:TNotifyOutputDeviceInfoEvent read FOnNotifyOutputDeviceInfo write FOnNotifyOutputDeviceInfo;
    property OnNotifyOutputFilterInfo:TNotifyOutputFilterInfoEvent read FOnNotifyOutputFilterInfo write FOnNotifyOutputFilterInfo;
    property OnNotifyStreamMimeType:TNotifyStreamMimeTypeEvent read FOnNotifyStreamMimeType write FOnNotifyStreamMimeType;
    property OnNotifyStreamDuration:TNotifyStreamDurationEvent read FOnNotifyStreamDuration write FOnNotifyStreamDuration;
    property OnNotifyStreamParameters:TNotifyStreamParametersEvent read FOnNotifyStreamParameters write FOnNotifyStreamParameters;
    property OnNotifyStreamProperties:TNotifyStreamPropertiesEvent read FOnNotifyStreamProperties write FOnNotifyStreamProperties;
    property OnNotifyCodecModule:TNotifyCodecModuleEvent read FOnNotifyCodecModule write FOnNotifyCodecModule;
    property OnNotifyCodecModuleInfo:TNotifyCodecModuleInfoEvent read FOnNotifyCodecModuleInfo write FOnNotifyCodecModuleInfo;
    property OnNotifyCodecDeviceInfo:TNotifyCodecDeviceInfoEvent read FOnNotifyCodecDeviceInfo write FOnNotifyCodecDeviceInfo;
    property OnNotifyCodecQuality:TNotifyCodecQualityEvent read FOnNotifyCodecQuality write FOnNotifyCodecQuality;
    property OnNotifyCodecEqualizer:TNotifyCodecEqualizerEvent read FOnNotifyCodecEqualizer write FOnNotifyCodecEqualizer;
    property OnNotifyNotificationMask:TNotifyNotificationMaskEvent read FOnNotifyNotificationMask write FOnNotifyNotificationMask;
    property OnNotifyDebugLevel:TNotifyDebugLevelEvent read FOnNotifyDebugLevel write FOnNotifyDebugLevel;
    property OnNotifyProgress:TNotifyProgressEvent read FOnNotifyProgress write FOnNotifyProgress;
    property OnNotifyDebug:TNotifyDebugEvent read FOnNotifyDebug write FOnNotifyDebug;
    property OnNotifyError:TNotifyErrorEvent read FOnNotifyError write FOnNotifyError;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Xaudio', [TXaudioPlayer]);
end;

{********************************************************************}
constructor TXaudioPlayer.Create(AOwner:TComponent);
begin
  { Init some fields }
  LibraryPath    := 'xaudio.dll';
  LibraryHandle  := 0;
  Player         := nil;
  PlayerPriority := XA_CONTROL_PRIORITY_HIGH;
  HiddenWindow   := 0;

  { Call inherited constructor }
  inherited Create(AOwner);

  { Create hidden window to handle messages }
  HiddenWindow := AllocateHWnd(OnWindowsMessage);
  if (HiddenWindow = 0) then
    Raise EXaudioException.Create('Cannot Create Hidden Window');

  { Reset DLL entry points }
  ResetExternalInterface;
end;

{********************************************************************}
destructor TXaudioPlayer.Destroy;
var
  Shadow: Pointer;
begin
  Shadow := Player;
  Player := nil;
  if (Shadow <> nil) then PlayerDelete(Shadow);
  ResetExternalInterface;
  if (HiddenWindow <> 0) then DeAllocatehWnd(HiddenWindow);
  inherited Destroy;
end;

{********************************************************************}
function TXaudioPlayer.Init : Boolean;
begin
  Init := CheckPlayerInstance;
end;

{********************************************************************}
function TXaudioPlayer.LoadSymbol(Name: PChar): Pointer;
var
  Symbol: Pointer;
begin
  if (LibraryHandle <> 0) then begin
    Symbol:= GetProcAddress(LibraryHandle, Name);
    if (Symbol = nil) then begin
      FreeLibrary(LibraryHandle);
      LibraryHandle := 0;
      Raise EXaudioException.Create('Cannot Find Symbol ' + Name + ' in Xaudio DLL');
    end;
  end
  else
    Symbol := nil;

  LoadSymbol := Symbol;
end;

{********************************************************************}
procedure TXaudioPlayer.ResetExternalInterface;
begin
  if (LibraryHandle <> 0) then FreeLibrary(LibraryHandle);
  LibraryHandle                := 0;
  @PlayerNew                   := nil;
  @PlayerDelete                := nil;
  @PlayerSetPriority           := nil;
  @PlayerGetPriority           := nil;
  @XaudioErrorString           := nil;
  @XaudioGetVersion            := nil;
  @ControlMessageSend_N        := nil;
  @ControlMessageSend_P        := nil;
  @ControlMessageSend_S        := nil;
  @ControlMessageSend_SS       := nil;
  @ControlMessageSend_SI       := nil;
  @ControlMessageSend_IPI      := nil;
  @ControlMessageSend_I        := nil;
  @ControlMessageSend_II       := nil;
  @ControlMessageSend_III      := nil;
  @ControlMessageSend_IIII     := nil;
  @ControlWin32ParamsToMessage := nil;
end;

{********************************************************************}
procedure TXaudioPlayer.LoadExternalInterface;
begin
  LibraryHandle := LoadLibrary(PChar(LibraryPath));
  if (LibraryHandle <> 0) then begin
    @PlayerNew                   := LoadSymbol('player_new');
    @PlayerDelete                := LoadSymbol('player_delete');
    @PlayerSetPriority           := LoadSymbol('player_set_priority');
    @PlayerGetPriority           := LoadSymbol('player_get_priority');
    @XaudioErrorString           := LoadSymbol('xaudio_error_string');
    @XaudioGetVersion            := LoadSymbol('xaudio_get_version');
    @ControlMessageSend_N        := LoadSymbol('control_message_send_N');
    @ControlMessageSend_P        := LoadSymbol('control_message_send_P');
    @ControlMessageSend_S        := LoadSymbol('control_message_send_S');
    @ControlMessageSend_SS       := LoadSymbol('control_message_send_SS');
    @ControlMessageSend_SI       := LoadSymbol('control_message_send_SI');
    @ControlMessageSend_IPI      := LoadSymbol('control_message_send_IPI');
    @ControlMessageSend_I        := LoadSymbol('control_message_send_I');
    @ControlMessageSend_II       := LoadSymbol('control_message_send_II');
    @ControlMessageSend_III      := LoadSymbol('control_message_send_III');
    @ControlMessageSend_IIII     := LoadSymbol('control_message_send_IIII');
    @ControlWin32ParamsToMessage := LoadSymbol('control_win32_params_to_message');
  end
  else
      raise EXaudioException.Create('Cannot Load Xaudio DLL (' + LibraryPath + ')');
end;

{********************************************************************}
function TXaudioPlayer.CheckPlayerInstance: Boolean;
var
  ApiVersion: Cardinal;
  ApiMajor: Cardinal;
  ApiMinor: Cardinal;
begin
  { Ensure that we have a player instance }
  if (Player <> nil) then begin
    CheckPlayerInstance := True;
    Exit;
  end;

  { Ensure DLL is loaded}
  if (LibraryHandle = 0) then begin
    LoadExternalInterface;
  end;

  if (LibraryHandle <> 0) then begin
    { check that the DLL we have has a compatible version }
    ApiVersion := XaudioGetVersion(XA_VERSION_ID_ASYNC_API);
    ApiMajor := (ApiVersion shr 16) and $FF;
    ApiMinor := (ApiVersion shr 8) and $FF;
    if (ApiMajor <> XA_ASYNC_API_MAJOR) or (ApiMinor <> XA_ASYNC_API_MINOR) then begin
      Raise EXaudioException.Create('Xaudio DLL API Mismatch'#13'Expected ' +
                 IntToStr(XA_ASYNC_API_MAJOR) + '.' + IntToStr(XA_ASYNC_API_MINOR) +
                 ', Got ' + IntToStr(ApiMajor) + '.' + IntToStr(ApiMinor));
      CheckPlayerInstance := False;
      Exit;
    end;
    { Instantiate a native player object }
    if (PlayerNew(Player, HiddenWindow) <> 0) then begin
      Raise EXaudioException.Create('Cannot Start Xaudio Player');
      Player := nil;
      CheckPlayerInstance := False;
      Exit;
    end;
    { If the priority has been changed, set it now }
    if (PlayerPriority <> XA_CONTROL_PRIORITY_HIGH) then
      PlayerSetPriority(Player, PlayerPriority);
  end
  else begin
    CheckPlayerInstance := False;
    Exit;
  end;

  CheckPlayerInstance := True;
end;

{************************************************************}
function TXaudioPlayer.TranslateMessage(var msg_from: TMessage; var msg_to: XA_Message): Integer;
begin
  if (Player <> nil) then
    TranslateMessage := ControlWin32ParamsToMessage(Player, msg_to, msg_from.Msg, msg_from.WParam, msg_from.LParam)
  else
    TranslateMessage := -1;
end;

{************************************************************}
procedure TXaudioPlayer.OnWindowsMessage(var win32_msg: TMessage);
var
  xa_msg: XA_Message;
begin
  { Default if this is not an Xaudio message }
  if (win32_msg.Msg < XA_MSG_BASE) then
    DefWindowProc(HiddenWindow, win32_msg.Msg, win32_msg.wParam, win32_msg.lParam);

  { Translate the Windows message into an Xaudio message }
  if (TranslateMessage(win32_msg, xa_msg) <> 0) then Exit;

  If win32_msg.msg=WM_QUERYENDSESSION
  Then win32_msg.Result:=Integer(True);

  If win32_msg.Msg=WM_ENDSESSION
  Then win32_msg.Result:=0;

  { If there is a hook function, call it now }
  if Assigned(FOnNotifyMessage) then
    FOnNotifyMessage(self, xa_msg);

  { Dispatch the message to the registered event handler }
  case xa_msg.code of
    XA_MSG_NOTIFY_READY:
       begin
         if Assigned(FOnNotifyReady) then
           FOnNotifyReady(self);
       end;

    XA_MSG_NOTIFY_ACK:
      begin
        if Assigned(FOnNotifyAck) then
          FOnNotifyAck(self, xa_msg.ack);
      end;

    XA_MSG_NOTIFY_NACK:
      begin
        if Assigned(FOnNotifyNack) then
          FOnNotifyNack(self, xa_msg.nack.command, xa_msg.nack.code);
      end;

    XA_MSG_NOTIFY_PONG:
      begin
        if Assigned(FOnNotifyPong) then
          FOnNotifyPong(self, xa_msg.tag);
      end;

    XA_MSG_NOTIFY_EXITED:
      begin
        if Assigned(FOnNotifyExited) then
          FOnNotifyExited(self);
      end;

    XA_MSG_NOTIFY_PLAYER_STATE:
      begin
        if Assigned(FOnNotifyPlayerState) then
          FOnNotifyPlayerState(self, xa_msg.state);
      end;

    XA_MSG_NOTIFY_PLAYER_MODE:
      begin
        if Assigned(FOnNotifyPlayerMode) then
          FOnNotifyPlayerMode(self, xa_msg.mode);
      end;

    XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_INTEGER:
      begin
        if Assigned(FOnNotifyPlayerEnvironmentInteger) then
          FOnNotifyPlayerEnvironmentInteger(self,
                                            xa_msg.environment_info.name,
                                            xa_msg.environment_info.integer_value);
      end;

    XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_STRING:
      begin
        if Assigned(FOnNotifyPlayerEnvironmentString) then
          FOnNotifyPlayerEnvironmentString(self,
                                           xa_msg.environment_info.name,
                                           xa_msg.environment_info.string_value);
      end;

    XA_MSG_NOTIFY_INPUT_STATE:
      begin
        if Assigned(FOnNotifyInputState) then
          FOnNotifyInputState(self, xa_msg.state);
      end;

    XA_MSG_NOTIFY_INPUT_NAME:
      begin
        if Assigned(FOnNotifyInputName) then
          FOnNotifyInputName(self, xa_msg.name);
      end;

    XA_MSG_NOTIFY_INPUT_CAPS:
      begin
        if Assigned(FOnNotifyInputCaps) then
          FOnNotifyInputCaps(self, xa_msg.caps);
      end;

    XA_MSG_NOTIFY_INPUT_POSITION:
      begin
        if Assigned(FOnNotifyInputPosition) then
          FOnNotifyInputPosition(self,
                                 xa_msg.position.offset,
                                 xa_msg.position.range);
      end;

    XA_MSG_NOTIFY_INPUT_POSITION_RANGE:
      begin
        if Assigned(FOnNotifyInputPositionRange) then
          FOnNotifyInputPositionRange(self, xa_msg.range);
      end;

    XA_MSG_NOTIFY_INPUT_TIMECODE:
      begin
        if Assigned(FOnNotifyInputTimecode) then
          FOnNotifyInputTimecode(self,
                                 xa_msg.timecode.h,
                                 xa_msg.timecode.m,
                                 xa_msg.timecode.s,
                                 xa_msg.timecode.f);
      end;

    XA_MSG_NOTIFY_INPUT_TIMECODE_GRANULARITY:
      begin
        if Assigned(FOnNotifyInputTimecodeGranularity) then
          FOnNotifyInputTimecodeGranularity(self, xa_msg.granularity);
      end;

    XA_MSG_NOTIFY_INPUT_MODULE:
      begin
        if Assigned(FOnNotifyInputModule) then
          FOnNotifyInputModule(self, xa_msg.module_id);
      end;

    XA_MSG_NOTIFY_INPUT_MODULE_INFO:
      begin
        if Assigned(FOnNotifyInputModuleInfo) then
          FOnNotifyInputModuleInfo(self,
                                   xa_msg.module_info.id,
                                   xa_msg.module_info.nb_devices,
                                   xa_msg.module_info.name,
                                   xa_msg.module_info.description);
      end;

    XA_MSG_NOTIFY_INPUT_DEVICE_INFO:
      begin
        if Assigned(FOnNotifyInputDeviceInfo) then
          FOnNotifyInputDeviceInfo(self,
                                   xa_msg.device_info.module_id,
                                   xa_msg.device_info.index,
                                   xa_msg.device_info.flags,
                                   xa_msg.device_info.name,
                                   xa_msg.device_info.description);
      end;

    XA_MSG_NOTIFY_INPUT_FILTER_INFO:
      begin
        if Assigned(FOnNotifyInputFilterInfo) then
          FOnNotifyInputFilterInfo(self,
                                   xa_msg.filter_info.id,
                                   xa_msg.filter_info.name);
      end;

    XA_MSG_NOTIFY_OUTPUT_STATE:
      begin
        if Assigned(FOnNotifyOutputState) then
          FOnNotifyOutputState(self, xa_msg.state);
      end;

    XA_MSG_NOTIFY_OUTPUT_NAME:
      begin
        if Assigned(FOnNotifyOutputName) then
          FOnNotifyOutputName(self, xa_msg.name);
      end;

    XA_MSG_NOTIFY_OUTPUT_CAPS:
      begin
        if Assigned(FOnNotifyOutputCaps) then
          FOnNotifyOutputCaps(self, xa_msg.caps);
      end;

    XA_MSG_NOTIFY_OUTPUT_VOLUME:
      begin
        if Assigned(FOnNotifyOutputVolume) then
          FOnNotifyOutputVolume(self,
                                xa_msg.volume.master_level,
                                xa_msg.volume.pcm_level,
                                xa_msg.volume.balance);
      end;

    XA_MSG_NOTIFY_OUTPUT_BALANCE:
      begin
        if Assigned(FOnNotifyOutputBalance) then
          FOnNotifyOutputBalance(self, xa_msg.volume.balance);
      end;

    XA_MSG_NOTIFY_OUTPUT_PCM_LEVEL:
      begin
        if Assigned(FOnNotifyOutputPcmLevel) then
          FOnNotifyOutputPcmLevel(self, xa_msg.volume.pcm_level);
      end;

    XA_MSG_NOTIFY_OUTPUT_MASTER_LEVEL:
      begin
        if Assigned(FOnNotifyOutputMasterLevel) then
          FOnNotifyOutputMasterLevel(self, xa_msg.volume.master_level);
      end;

    XA_MSG_NOTIFY_OUTPUT_CHANNELS:
      begin
        if Assigned(FOnNotifyOutputChannels) then
          FOnNotifyOutputChannels(self, xa_msg.channels);
      end;

    XA_MSG_NOTIFY_OUTPUT_PORTS:
      begin
        if Assigned(FOnNotifyOutputPorts) then
          FOnNotifyOutputPorts(self, xa_msg.ports);
      end;

    XA_MSG_NOTIFY_OUTPUT_MODULE:
      begin
        if Assigned(FOnNotifyOutputModule) then
          FOnNotifyOutputModule(self, xa_msg.module_id);
      end;

    XA_MSG_NOTIFY_OUTPUT_MODULE_INFO:
      begin
        if Assigned(FOnNotifyOutputModuleInfo) then
          FOnNotifyOutputModuleInfo(self,
                                    xa_msg.module_info.id,
                                    xa_msg.module_info.nb_devices,
                                    xa_msg.module_info.name,
                                    xa_msg.module_info.description);
      end;

    XA_MSG_NOTIFY_OUTPUT_DEVICE_INFO:
      begin
        if Assigned(FOnNotifyOutputDeviceInfo) then
          FOnNotifyOutputDeviceInfo(self,
                                    xa_msg.device_info.module_id,
                                    xa_msg.device_info.index,
                                    xa_msg.device_info.flags,
                                    xa_msg.device_info.name,
                                    xa_msg.device_info.description);
      end;

    XA_MSG_NOTIFY_OUTPUT_FILTER_INFO:
      begin
        if Assigned(FOnNotifyOutputFilterInfo) then
          FOnNotifyOutputFilterInfo(self,
                                    xa_msg.filter_info.id,
                                    xa_msg.filter_info.name);
      end;

    XA_MSG_NOTIFY_STREAM_MIME_TYPE:
      begin
        if Assigned(FOnNotifyStreamMimeType) then
          FOnNotifyStreamMimeType(self, xa_msg.mime_type);
      end;

    XA_MSG_NOTIFY_STREAM_DURATION:
      begin
        if Assigned(FOnNotifyStreamDuration) then
          FOnNotifyStreamDuration(self, xa_msg.duration);
      end;

    XA_MSG_NOTIFY_STREAM_PARAMETERS:
      begin
        if Assigned(FOnNotifyStreamParameters) then
          FOnNotifyStreamParameters(self,
                                    xa_msg.stream_parameters.frequency,
                                    xa_msg.stream_parameters.bitrate,
                                    xa_msg.stream_parameters.nb_channels);
      end;

    XA_MSG_NOTIFY_STREAM_PROPERTIES:
      begin
        if Assigned(FOnNotifyStreamProperties) then
          FOnNotifyStreamProperties(self,
                                    xa_msg.properties.nb_properties,
                                    xa_msg.properties.properties);
      end;

    XA_MSG_NOTIFY_CODEC_MODULE:
      begin
        if Assigned(FOnNotifyCodecModule) then
          FOnNotifyCodecModule(self, xa_msg.module_id);
      end;

    XA_MSG_NOTIFY_CODEC_MODULE_INFO:
      begin
        if Assigned(FOnNotifyCodecModuleInfo) then
          FOnNotifyCodecModuleInfo(self,
                                   xa_msg.module_info.id,
                                   xa_msg.module_info.nb_devices,
                                   xa_msg.module_info.name,
                                   xa_msg.module_info.description);
      end;

    XA_MSG_NOTIFY_CODEC_DEVICE_INFO:
      begin
        if Assigned(FOnNotifyCodecDeviceInfo) then
          FOnNotifyCodecDeviceInfo(self,
                                   xa_msg.device_info.module_id,
                                   xa_msg.device_info.index,
                                   xa_msg.device_info.flags,
                                   xa_msg.device_info.name,
                                   xa_msg.device_info.description);
      end;

    XA_MSG_NOTIFY_CODEC_QUALITY:
      begin
        if Assigned(FOnNotifyCodecQuality) then
          FOnNotifyCodecQuality(self, xa_msg.quality);
        end;

    XA_MSG_NOTIFY_CODEC_EQUALIZER:
      begin
        if Assigned(FOnNotifyCodecEqualizer) then
          FOnNotifyCodecEqualizer(self, xa_msg.equalizer^);
      end;

    XA_MSG_NOTIFY_NOTIFICATION_MASK:
      begin
        if Assigned(FOnNotifyNotificationMask) then
          FOnNotifyNotificationMask(self, xa_msg.notification_mask);
      end;

    XA_MSG_NOTIFY_DEBUG_LEVEL:
      begin
        if Assigned(FOnNotifyDebugLevel) then
          FOnNotifyDebugLevel(self, xa_msg.debug_level);
      end;

    XA_MSG_NOTIFY_PROGRESS:
      begin
        if Assigned(FOnNotifyProgress) then
          FOnNotifyProgress(self,
                            xa_msg.progress.source,
                            xa_msg.progress.code,
                            xa_msg.progress.value,
                            xa_msg.progress.msg);
      end;

    XA_MSG_NOTIFY_DEBUG:
      begin
        if Assigned(FOnNotifyDebug) then
          FOnNotifyDebug(self,
                         xa_msg.debug.source,
                         xa_msg.debug.level,
                         xa_msg.debug.msg);
      end;

    XA_MSG_NOTIFY_ERROR:
      begin
        if Assigned(FOnNotifyError) then
          FOnNotifyError(self,
                         xa_msg.error.source,
                         xa_msg.error.code,
                         xa_msg.error.msg);
      end;

  end;
end;

{************************************************************}
function TXaudioPlayer.GetVersion(VersionId: Byte): Cardinal;
begin
  if (Player <> nil) then
    GetVersion := XaudioGetVersion(VersionId)
  else
    GetVersion := 0;
end;

{************************************************************}
procedure TXaudioPlayer.SetPriority(Priority: Cardinal);
begin
  if (Player <> nil) then
    PlayerSetPriority(Player, Priority)
  else
    PlayerPriority := Priority;
end;

{************************************************************}
function TXaudioPlayer.GetPriority: Cardinal;
begin
  if (Player <> nil) then
    GetPriority := PlayerGetPriority(Player)
  else
    GetPriority := PlayerPriority;
end;

{************************************************************}
function TXaudioPlayer.ErrorString(Code: Integer): string;
begin
  if CheckPlayerInstance then
    ErrorString := XaudioErrorString(Code)
  else
    ErrorString := '';
end;

{************************************************************}
procedure TXaudioPlayer.Ping(Tag: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_COMMAND_PING, Tag);
end;

{************************************************************}
procedure TXaudioPlayer.Play;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_PLAY);
end;

{************************************************************}
procedure TXaudioPlayer.Pause;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_PAUSE);
end;

{************************************************************}
procedure TXaudioPlayer.Stop;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_STOP);
end;

{************************************************************}
procedure TXaudioPlayer.Synchronize;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_SYNC);
end;

{************************************************************}
procedure TXaudioPlayer.InputSeek(Offset: Cardinal; Range: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_II(Player, XA_MSG_COMMAND_SEEK, Offset, Range);
end;

{************************************************************}
procedure TXaudioPlayer.InputOpen(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_COMMAND_INPUT_OPEN, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.InputClose;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_INPUT_CLOSE);
end;

{************************************************************}
procedure TXaudioPlayer.InputSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_IPI(Player, XA_MSG_COMMAND_INPUT_SEND_MESSAGE, MsgType, Data, Size);
end;

{************************************************************}
procedure TXaudioPlayer.InputAddFilter(const Name: String; Where: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SI(Player, XA_MSG_COMMAND_INPUT_ADD_FILTER, PChar(Name), Where);
end;

{************************************************************}
procedure TXaudioPlayer.InputRemoveFilter(const Name: String; ID: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SI(Player, XA_MSG_COMMAND_INPUT_REMOVE_FILTER, PChar(Name), ID);
end;

{************************************************************}
procedure TXaudioPlayer.InputFilterList;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_INPUT_FILTERS_LIST);
end;

{************************************************************}
procedure TXaudioPlayer.InputModuleRegister(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_COMMAND_INPUT_MODULE_REGISTER, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.InputModuleQuery(ID: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_COMMAND_INPUT_MODULE_QUERY, ID);
end;

{************************************************************}
procedure TXaudioPlayer.InputModulesList;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_INPUT_MODULES_LIST);
end;

{************************************************************}
procedure TXaudioPlayer.OutputOpen(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_COMMAND_OUTPUT_OPEN, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.OutputClose;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_CLOSE);
end;

{************************************************************}
procedure TXaudioPlayer.OutputMute;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_MUTE);
end;

{************************************************************}
procedure TXaudioPlayer.OutputUnmute;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_UNMUTE);
end;

{************************************************************}
procedure TXaudioPlayer.OutputReset;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_RESET);
end;

{************************************************************}
procedure TXaudioPlayer.OutputDrain;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_DRAIN);
end;

{************************************************************}
procedure TXaudioPlayer.OutputSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_IPI(Player, XA_MSG_COMMAND_OUTPUT_SEND_MESSAGE, MsgType, Data, Size);
end;

{************************************************************}
procedure TXaudioPlayer.OutputAddFilter(const Name: String; Where: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SI(Player, XA_MSG_COMMAND_OUTPUT_ADD_FILTER, PChar(Name), Where);
end;

{************************************************************}
procedure TXaudioPlayer.OutputRemoveFilter(const Name: String; ID: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SI(Player, XA_MSG_COMMAND_OUTPUT_REMOVE_FILTER, PChar(Name), ID);
end;

{************************************************************}
procedure TXaudioPlayer.OutputFilterList;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_FILTERS_LIST);
end;

{************************************************************}
procedure TXaudioPlayer.OutputModuleRegister(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_COMMAND_OUTPUT_MODULE_REGISTER, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.OutputModuleQuery(ID: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_COMMAND_OUTPUT_MODULE_QUERY, ID);
end;

{************************************************************}
procedure TXaudioPlayer.OutputModulesList;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_OUTPUT_MODULES_LIST);
end;

{************************************************************}
procedure TXaudioPlayer.CodecModuleRegister(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_COMMAND_CODEC_MODULE_REGISTER, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.CodecModuleQuery(ID: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_COMMAND_CODEC_MODULE_QUERY, ID);
end;

{************************************************************}
procedure TXaudioPlayer.CodecModulesList;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_COMMAND_CODEC_MODULES_LIST);
end;

{************************************************************}
procedure TXaudioPlayer.CodecSendMessage(MsgType: Word; const Data: Pointer; Size: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_IPI(Player, XA_MSG_COMMAND_CODEC_SEND_MESSAGE, MsgType, Data, Size);
end;

{************************************************************}
procedure TXaudioPlayer.SetPlayerMode(Mode: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_PLAYER_MODE, Mode);
end;

{************************************************************}
procedure TXaudioPlayer.GetPlayerMode;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_PLAYER_MODE);
end;

{************************************************************}
procedure TXaudioPlayer.SetPlayerEnvironmentInteger(const Name: String; Value: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SI(Player, XA_MSG_SET_PLAYER_ENVIRONMENT_INTEGER, PChar(Name), Value);
end;

{************************************************************}
procedure TXaudioPlayer.GetPlayerEnvironmentInteger(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_GET_PLAYER_ENVIRONMENT_INTEGER, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.SetPlayerEnvironmentString(const Name: String; const Value: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_SS(Player, XA_MSG_SET_PLAYER_ENVIRONMENT_STRING, PChar(Name), PChar(Value));
end;

{************************************************************}
procedure TXaudioPlayer.GetPlayerEnvironmentString(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_GET_PLAYER_ENVIRONMENT_STRING, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.UnsetPlayerEnvironment(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_UNSET_PLAYER_ENVIRONMENT, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.SetInputModule(ID: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_INPUT_MODULE, ID);
end;

{************************************************************}
procedure TXaudioPlayer.GetInputModule;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_INPUT_MODULE);
end;

{************************************************************}
procedure TXaudioPlayer.SetInputName(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_SET_INPUT_NAME, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.GetInputName;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_INPUT_NAME);
end;

{************************************************************}
procedure TXaudioPlayer.SetInputPositionRange(Range: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_INPUT_POSITION_RANGE, Range);
end;

{************************************************************}
procedure TXaudioPlayer.GetInputPositionRange;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_INPUT_POSITION_RANGE);
end;

{************************************************************}
procedure TXaudioPlayer.SetInputTimecodeGranularity(Granularity: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_INPUT_TIMECODE_GRANULARITY, Granularity);
end;

{************************************************************}
procedure TXaudioPlayer.GetInputTimecodeGranularity;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_INPUT_TIMECODE_GRANULARITY);
end;

{************************************************************}
procedure TXaudioPlayer.SetOutputModule(ID: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_OUTPUT_MODULE, ID);
end;

{************************************************************}
procedure TXaudioPlayer.GetOutputModule;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_OUTPUT_MODULE);
end;

{************************************************************}
procedure TXaudioPlayer.SetOutputName(const Name: String);
begin
  if CheckPlayerInstance then
    ControlMessageSend_S(Player, XA_MSG_SET_OUTPUT_NAME, PChar(Name));
end;

{************************************************************}
procedure TXaudioPlayer.GetOutputName;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_OUTPUT_NAME);
end;

{************************************************************}
procedure TXaudioPlayer.SetOutputVolume(Balance: Integer; PcmLevel: Integer; MasterLevel: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_III(Player, XA_MSG_SET_OUTPUT_VOLUME, Balance, PcmLevel, MasterLevel);
end;

{************************************************************}
procedure TXaudioPlayer.GetOutputVolume;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_OUTPUT_VOLUME);
end;

{************************************************************}
procedure TXaudioPlayer.SetOutputChannels(Channels: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_OUTPUT_CHANNELS, Channels);
end;

{************************************************************}
procedure TXaudioPlayer.GetOutputChannels;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_OUTPUT_CHANNELS);
end;

{************************************************************}
procedure TXaudioPlayer.SetOutputPorts(Ports: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_OUTPUT_PORTS, Ports);
end;

{************************************************************}
procedure TXaudioPlayer.GetOutputPorts;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_OUTPUT_PORTS);
end;

{************************************************************}
procedure TXaudioPlayer.SetCodecQuality(Quality: Byte);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_CODEC_QUALITY, Quality);
end;

{************************************************************}
procedure TXaudioPlayer.GetCodecQuality;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_CODEC_QUALITY);
end;

{************************************************************}
procedure TXaudioPlayer.SetCodecEqualizer(Equalizer: PXA_EqualizerInfo);
begin
  if CheckPlayerInstance then
    ControlMessageSend_P(Player, XA_MSG_SET_CODEC_EQUALIZER, Pointer(Equalizer));
end;

{************************************************************}
procedure TXaudioPlayer.GetCodecEqualizer;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_CODEC_EQUALIZER);
end;

{************************************************************}
procedure TXaudioPlayer.SetNotificationMask(Mask: Cardinal);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_NOTIFICATION_MASK, Mask);
end;

{************************************************************}
procedure TXaudioPlayer.GetNotificationMask;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_NOTIFICATION_MASK);
end;

{************************************************************}
procedure TXaudioPlayer.SetDebugLevel(Level: Integer);
begin
  if CheckPlayerInstance then
    ControlMessageSend_I(Player, XA_MSG_SET_DEBUG_LEVEL, Level);
end;

{************************************************************}
procedure TXaudioPlayer.GetDebugLevel;
begin
  if CheckPlayerInstance then
    ControlMessageSend_N(Player, XA_MSG_GET_DEBUG_LEVEL);
end;

{************************************************************}
end.
