unit xGapplay;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, extctrls,
     xPlayerInfo;

type TxGapplay = class (TComponent)
     private
      fTimer:TTimer;
      fGap,fCnt,fIdx:longint;
      fTimeEp,fTimeRm:longint;
      fOnPlay,fOnStop,fOnPause,fOnEOF:TNotifyEvent;
      fOnTime:TxPlayerTimeEvent;
      fOnPos:TxPlayerPositionEvent;
      procedure OnTimer(Sender:TObject);
     protected
     public
      constructor Create(AOwner:TComponent); override;
      destructor Destroy; override;
     published
      // ----------------------------------
      procedure Play(TimeEplased,TimeRemaining,Gap:longint);
      procedure Stop;
      procedure Pause;
      // ----------------------------------
      property OnStop:TNotifyEvent read fOnStop write fOnStop;
      property OnPlay:TNotifyEvent read fOnPlay write fOnPlay;
      property OnPause:TNotifyEvent read fOnPause write fOnPause;
      property OnEOF:TNotifyEvent read fOnEOF write fOnEOF;
      property OnTime:TxPlayerTimeEvent read fOnTime write fOnTime;
      property OnPosition:TxPlayerPositionEvent read fOnPos write fOnPos;
     End;

implementation

{==============================================================================}
constructor TxGapplay.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 fTimeEp:=0; fTimeRm:=0;
 fTimer:=TTimer.Create(Self); fTimer.Interval:=200; fTimer.Enabled:=False;
 fTimer.OnTimer:=OnTimer;
end;
{==============================================================================}
destructor TxGapplay.Destroy;
begin
 fTimer.Free;
 inherited Destroy;
end;
{==============================================================================}
procedure TxGapplay.OnTimer(Sender:TObject);
begin
 Inc(fCnt);  If fCnt>5 Then fCnt:=1;
 If fCnt=5 Then // 1000 milisec
 Begin
  If Assigned(fOnPos) Then fOnPos(Self,1000);
  Inc(fTimeEp); Dec(fTimeRm);
  If Assigned(fOnTime) Then fOnTime(Self,fTimeEp,fTimeRm);
  Inc(fIdx); If fIdx>=fGap Then
  Begin fTimer.Enabled:=False; If Assigned(fOnEof) Then fOnEof(Self); exit; End;
 End;
end;
{==============================================================================}
{                              Play Stop Pause Seek                            }
{==============================================================================}
procedure TxGapplay.Play(TimeEplased,TimeRemaining,Gap:longint);
begin
 //If Gap=0 Then Begin If Assigned(fOnEof) Then fOnEof(Self); exit; End;
 fIdx:=-1; fCnt:=3; fGap:=Gap;
 fTimeEp:=TimeEplased; fTimeRm:=TimeRemaining;
 fTimer.Enabled:=True;
end;
{==============================================================================}
procedure TxGapplay.Stop;
begin
 fTimer.Enabled:=False; If Assigned(fOnStop) Then fOnStop(Self);
end;
{==============================================================================}
procedure TxGapplay.Pause;
begin
 If fTimer.Enabled
 Then Begin fTimer.Enabled:=False; If Assigned(fOnPause) Then fOnPause(Self); End
 Else Begin fTimer.Enabled:=True; If Assigned(fOnPlay) Then fOnPlay(Self); End;
end;
{==============================================================================}
end.
