unit xSongList;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, mxarrays, xPlayerInfo;

type TxMoveDirection = (mdUp,mdDown);

type PSong = ^TSong;

type TSongList = class (TObject)
     private
      fList:TList;
      function  GetSong(Indx:integer):PSong;
      function  GetCount:integer;
     protected
     public
      constructor Create;
      destructor Destroy; override;
      // -----------------------------------------------------------
      property  Songs[Indx:integer]:PSong read GetSong{ write SetSong};
      property  Count:integer read GetCount;
      function  Add(Value:TSong):integer;
      procedure Insert(Indx:integer; Value:TSong);
      procedure Delete(Indx:integer);
      procedure Clear;
      procedure Exchange(Indx1,Indx2:integer);
      procedure MoveSelected(Direction:TxMoveDirection);
      procedure SetActive(Indx:integer);
      function GetActive:integer;
      procedure SetLastSelected(Indx:integer);
      function GetLastSelected:integer;
      procedure SelectRange(Indx1,Indx2:integer);
      procedure SelectAll;
      procedure UnselectAll;
      procedure InvertSelect;
     End;

implementation

{------------------------------------------------------------------------------}
constructor TSongList.Create;
begin
  inherited Create;
  fList:=TList.Create;
end;
{------------------------------------------------------------------------------}
destructor TSongList.Destroy;
begin
  Clear;
  fList.Free;
  inherited Destroy;
end;
{==============================================================================}
function TSongList.Add(Value:TSong):integer;
var P:PSong;
begin
 GetMem(P,SizeOf(TSong)); Move(Value,P^,SizeOf(TSong));
 Result:=fList.Add(P);
end;
{------------------------------------------------------------------------------}
procedure TSongList.Insert(Indx:integer; Value:TSong);
var P:PSong;
    i:integer;
begin
 i:=Indx; If i<0 Then i:=0; If i>fList.Count Then i:=fList.Count;
 GetMem(P,SizeOf(TSong)); Move(Value,P^,SizeOf(TSong));
 fList.Insert(i,P);
end;
{------------------------------------------------------------------------------}
procedure TSongList.Delete(Indx:integer);
begin
 If (Indx<0) or (Indx>fList.Count-1) Then exit;
 FreeMem(fList.Items[Indx],SizeOf(TSong)); fList.Delete(Indx);
end;
{------------------------------------------------------------------------------}
procedure TSongList.Clear;
var i:integer;
begin
 For i:=0 To fList.Count-1 Do FreeMem(fList.Items[i],SizeOf(TSong));
 fList.Clear;
end;
{------------------------------------------------------------------------------}
procedure TSongList.Exchange(Indx1,Indx2:integer);
begin
 fList.Exchange(Indx1,Indx2);
end;
{==============================================================================}
function TSongList.GetSong(Indx:integer):PSong;
begin
 Result:=fList.Items[Indx];
end;
{==============================================================================}
function  TSongList.GetCount:integer;
begin
 Result:=fList.Count;
end;
{------------------------------------------------------------------------------}
procedure TSongList.SetActive(Indx:integer);
var i:integer;
begin
 For i:=0 To fList.Count-1 Do
 If i<>Indx Then TSong(fList.Items[i]^).Active:=False Else TSong(fList.Items[i]^).Active:=True;
end;
{------------------------------------------------------------------------------}
function TSongList.GetActive:integer;
var i:integer;
begin
 Result:=-1; For i:=0 To fList.Count-1 Do
 If TSong(fList.Items[i]^).Active Then Begin Result:=i; Break; End;
end;
{------------------------------------------------------------------------------}
procedure TSongList.SetLastSelected(Indx:integer);
var i:integer;
begin
 For i:=0 To fList.Count-1 Do
 If i<>Indx Then TSong(fList.Items[i]^).LastSelected:=False Else TSong(fList.Items[i]^).LastSelected:=True;
end;
{------------------------------------------------------------------------------}
function TSongList.GetLastSelected:integer;
var i:integer;
begin
 Result:=-1; For i:=0 To fList.Count-1 Do
 If TSong(fList.Items[i]^).LastSelected Then Begin Result:=i; Break; End;
end;
{------------------------------------------------------------------------------}
procedure TSongList.MoveSelected(Direction:TxMoveDirection);
var i:integer;
begin
 If fList.Count=0 Then exit;
 If Direction=mdUp
 Then Begin
  If not TSong(fList.Items[0]^).Selected Then
  For i:=1 To fList.Count-1 Do If TSong(fList.Items[i]^).Selected Then fList.Exchange(i-1,i);
 End
 Else Begin
  If not TSong(fList.Items[fList.Count-1]^).Selected Then
  For i:=fList.Count-2 DownTo 0 Do If TSong(fList.Items[i]^).Selected Then fList.Exchange(i+1,i);
 End;
end;
{------------------------------------------------------------------------------}
procedure TSongList.SelectRange(Indx1,Indx2:integer);
var i,i1,i2:integer;
begin
 If Indx1<Indx2 Then Begin i1:=Indx1; i2:=Indx2 End Else Begin i2:=Indx1; i1:=Indx2 End;
 For i:=0 To fList.Count-1 Do If (i>=i1) and (i<=i2) Then TSong(fList.Items[i]^).Selected:=True;
end;
{------------------------------------------------------------------------------}
procedure TSongList.SelectAll;
var i:integer;
begin
 For i:=0 To fList.Count-1 Do TSong(fList.Items[i]^).Selected:=True;
end;
{------------------------------------------------------------------------------}
procedure TSongList.UnselectAll;
var i:integer;
begin
 For i:=0 To fList.Count-1 Do TSong(fList.Items[i]^).Selected:=False;
end;
{------------------------------------------------------------------------------}
procedure TSongList.InvertSelect;
var i:integer;
begin
 For i:=0 To fList.Count-1
 Do TSong(fList.Items[i]^).Selected:=not TSong(fList.Items[i]^).Selected;
end;
{==============================================================================}
end.
